/*
 * Licensed Materials - Property of IBM
 * 5648-C63
 * (C) Copyright IBM Corp. 1999, 2000
 */

#ifdef __cplusplus
extern "C" {
#endif

#include <BipCni.h>

#ifndef min                                   
#define min(x,y) (((x)<(y)) ? (x) : (y))      
#endif                                        

/* ---------------------------------------------------------------- */
/*                     Internal constants                           */
/*                                                                  */
/* The interface expects some CciChar strings to be passed. These   */
/* have to be constructed from char strings using the supplied      */
/* utilities. The char constants are defined here along with the    */
/* static CciChar variables which will contain these constants      */
/* converted into CciChar format.                                   */
/*                                                                  */
/* ---------------------------------------------------------------- */
#define CONST_ZERO                           "0"
const CciChar * constZero                   = 0;

#define CONST_MQSERIES_INTEGRATOR_2          "MQSIv201"
const CciChar * constMQSeriesIntegrator2    = 0;

/* Parser constant strings */

#define CONST_MQ_PROPERTY_PARSER             "MqPropertyParser"
const CciChar * constMqPropertyParser       = 0;

#define CONST_MQMD_PARSER                    "MQHMD"
const CciChar * constMQHMDParser            = 0;

#define CONST_MQHRF2_PARSER                  "MQHRF2"
const CciChar * constMQHRF2Parser           = 0;

#define CONST_XML_PARSER                     "xml"
const CciChar * constXMLParser              = 0;

/* MQMD Defined constant strings */

#define CONST_USER_IDENTIFIER                "UserIdentifier"
const CciChar * constUserIdentifier         = 0;

#define CONST_FORMAT                         "Format"
const CciChar * constFormat                 = 0;
int             constFormatLength           = 0;

#define CONST_MESSAGE_TYPE                   "MsgType"
const CciChar * constMsgType                = 0;

#define CONST_REPORT                         "Report"
const CciChar * constReport                 = 0;

#define CONST_TRANSACTIONAL                  "Transactional"
const CciChar * constTransactional          = 0;

/* RFH2 Defined constant strings */

#define CONST_SYS_PSC_FOLDER                 "psc"
const CciChar * constPscFolder              = 0;

/* PubSub Constants */

#define CONST_SYS_TOPIC                      "$SYS/Broker/"
const CciChar * constSysTopic               = 0;
int             constSysTopicLength         = 0;

#define CONST_TOPIC_EXCEPTION_STRING         "/Exception/"
const CciChar * constTopicExceptionString   = 0;
int         constTopicExceptionStringLength = 0;     

#define CONST_TOPIC_SEPERATOR                "/"
const CciChar * constTopicSeperator         = 0;
int             constTopicSeperatorLength   = 0;

#define CONST_COMMAND_STRING                 "Command"
const CciChar * constCommandString          = 0;

#define CONST_PUBLISH_STRING                 "Publish"
const CciChar * constPublishString          = 0;
int             constPublishStringLength    = 0;

#define CONST_TOPIC_STRING                   "Topic"
const CciChar * constTopicString            = 0;

/* XML Constants */

#define CONST_BROKER_STRING                  "Broker"
const CciChar * constBrokerString           = 0;

#define CONST_LABEL_STRING                   "label"
const CciChar * constLabelString            = 0;

#define CONST_EXECUTION_GROUP_STRING         "ExecutionGroup"
const CciChar * constExecutionGroupString   = 0;

#define CONST_MESSAGEFLOW_STRING             "MessageFlow"
const CciChar * constMessageFlowString      = 0;

#define CONST_EXCEPTION_STRING               "Exception"
const CciChar * constExceptionString        = 0;

#define CONST_VERSION_STRING                 "Version"
const CciChar * constVersionString          = 0;

#define CONST_TYPE_STRING                    "Type"
const CciChar * constTypeString             = 0;

#define CONST_MESSAGE_NUMBER_STRING          "MessageNumber"
const CciChar * constMessageNumberString    = 0;

#define CONST_INSERT_STRING                  "Insert"
const CciChar * constInsertString           = 0;

#define CONST_FILE_NAME_STRING               "FileName"
const CciChar * constFileNameString         = 0;

#define CONST_LINE_NUMBER_STRING             "LineNumber"
const CciChar * constLineNumberString       = 0;

#define CONST_FUNCTION_NAME_STRING           "FunctionName"
const CciChar * constFunctionNameString     = 0;

#define CONST_TRACE_TEXT_STRING              "TraceText"
const CciChar * constTraceTextString        = 0;

#define CONST_OBJECT_NAME_STRING             "ObjectName"
const CciChar * constObjectNameString       = 0;

#define CONST_OBJECT_TYPE_STRING             "ObjectType"
const CciChar * constObjectTypeString       = 0;

/* Terminal Constants */

#define CONST_IN_TERMINAL                    "in"
const CciChar * constInTerminal             = 0;

#define CONST_PUBLISH_TERMINAL               "publish"
const CciChar * constPublishTerminal        = 0;

#define CONST_OUT_TERMINAL                   "out"
const CciChar * constOutTerminal            = 0;

#define CONST_FAILURE_TERMINAL               "failure"
const CciChar * constFailureTerminal        = 0;

/* Node Constants */

#define CONST_PUBLISH_EXCEPTION_NODE         "ComIbmPublishExceptionNode"
const CciChar * constPublishExceptionNode   = 0;

#define CONST_PUBLISH_EXCEPTION_NODE_FACTORY  "ComIbmPublishExceptionNodeFactory"
const CciChar * constPublishExceptionNodeFactory = 0;

#define CONST_USERID_STRING                  "userId"
const CciChar * constUserIdString           = 0;
                                             
#define MAX_ATTR_NAME_LEN     128
#define MAX_NODE_NAME_LEN     128
#define MAX_STRING_SIZE       256
#define MAX_TERMINAL_NAME_LEN 256
#define CNI_TYPE_INTEGER        1
#define CNI_TYPE_STRING         2

#if defined(__CCI_SOLARIS__)
#define CCI_CHECK_RC()                                                                        \
   if (rc != CCI_SUCCESS) {                                                                   \
     if (rc == CCI_EXCEPTION) cciRethrowLastException(0);                                     \
     else {                                                                                   \
       cciLog(&rc, CCI_LOG_ERROR, __FILE__, __LINE__, "",                                     \
              (CciChar*)constMQSeriesIntegrator2,                                             \
              0, "", 0);                                                                      \
       return;                                                                                \
     }                                                                                        \
   }
#else
#define CCI_CHECK_RC()                                                                        \
   if (rc != CCI_SUCCESS) {                                                                   \
     if (rc == CCI_EXCEPTION) cciRethrowLastException(0);                                     \
     else {                                                                                   \
       cciLog(&rc, CCI_LOG_ERROR, __FILE__, __LINE__, "", L"MQSIv201", 0, "", 0);             \
       return;                                                                                \
     }                                                                                        \
   }
#endif

typedef struct attributeTblEntry {
  void*    next;                    /* Pointer to next entry */
  void*    valptr;                  /* Pointer to value */
  int      type;                    /* Value type */
  CciChar  name[MAX_ATTR_NAME_LEN]; /* Attribute name */
} ATTRIBUTE_TBL_ENTRY;

typedef struct terminalListEntry {
  void*        next;                        /* Pointer to next entry */
  CciTerminal* handle;                      /* Handle to terminal object */
  CciChar      name[MAX_TERMINAL_NAME_LEN]; /* Terminal name */
} TERMINAL_LIST_ENTRY;

typedef struct context {
  CciNode*             nodeObject;                  /* Handle for node object */
  ATTRIBUTE_TBL_ENTRY* attrListHead;                /* Head of linked list of attributes */
  ATTRIBUTE_TBL_ENTRY* attrListPrevious;            /* Previous entry in attribute list */
  TERMINAL_LIST_ENTRY* inputTerminalListHead;       /* Head of linked list of input terminal handles */
  TERMINAL_LIST_ENTRY* inputTerminalListPrevious;   /* Previous entry in input terminal list */
  TERMINAL_LIST_ENTRY* outputTerminalListHead;      /* Head of linked list of output terminal handles */
  TERMINAL_LIST_ENTRY* outputTerminalListPrevious;  /* Previous entry in output terminal list */
  int                  trace;                       /* Flag: Trace active? */
  FILE*                tracefile;                   /* Trace file stream */
  CciChar              nodeName[MAX_NODE_NAME_LEN]; /* Node name */
} NODE_CONTEXT_ST;

/* Function prototypes */

ATTRIBUTE_TBL_ENTRY *insAttrTblEntry(
  NODE_CONTEXT_ST* context,
  CciChar*         attrName,
  int              type
);

void *getInputTerminalHandle(
  NODE_CONTEXT_ST* context,
  CciChar*         terminalName
);

TERMINAL_LIST_ENTRY *insInputTerminalListEntry(
  NODE_CONTEXT_ST* context,
  CciChar*         terminalName 
);

void *getOutputTerminalHandle(
  NODE_CONTEXT_ST* context,
  CciChar*         terminalName
);

TERMINAL_LIST_ENTRY *insOutputTerminalListEntry(
  NODE_CONTEXT_ST* context,
  CciChar*         terminalName 
);

CciContext* _PublishException_createNodeContext(
  CciFactory* factoryObject,
  CciChar*    nodeName,
  CciNode*    nodeObject
);

int _getAttributeName(
  CciContext* context,
  int         index,
  CciChar*    buffer,
  int         bufsize
);

int _setAttribute(
  CciContext* context,
  CciChar*    attrName,
  CciChar*    attrValue
);

int _getAttribute(
  CciContext* context,
  CciChar*    attrName,
  CciChar*    buffer,
  int         bufsize
);

void _PublishException_evaluate(
  CciContext* context, 
  CciContext* destinationList,
  CciContext* exceptionList,
  CciContext* message
);

CciChar* CciString(
  const char* source
);

void createIntElement(
  CciElement *attachElement,
  CciChar    *elementName,
  CciInt      intValue
);

void createBoolElement(
  CciElement *attachElement,
  CciChar    *elementName,
  CciBool     boolValue
);

void createCharElement(
      CciElement *attachElement,
      CciChar    *elementName,
const CciChar    *charValue,
      CciSize     charSize
);

void CciCharCpy(
  CciChar* target, 
  const CciChar* source
);

int CciCharLen(
  const CciChar* s
);

void CciCharCat(
  CciChar* target, 
  const CciChar* source
);

#if defined(__CCI_SOLARIS__)

const char* mbString(
  const CciChar* source
);

void CciCharNCpy(
  CciChar* target,
  const CciChar* source,
  unsigned int size
);

int CciCharCmp(
  const CciChar * s1,
  const CciChar* s2
);

#endif


#ifdef __cplusplus
}
#endif

